import monitor.*;

//******************************************************************************/ 
// definizione di una classe che estende Monitor				/
//******************************************************************************/ 

public class DepositoBagagli extends Monitor {

//******************************************************************************/ 
// dichiarazione delle variabili di stato del Monitor				/
//******************************************************************************/ 

        int vani;   			// numero di vani
        int bagagli;        	// numero di bagagli per vano
        int cap_vano[];     	// numero di bagagli nel vano
        int contatore_sospesi;  // contatore dei processi sospesi

//******************************************************************************/ 
// dichiarazione di variabili condition del Monitor				/
//******************************************************************************/ 
        
        Cond coda;  		// variabili condition

//******************************************************************************/ 
// costruttore e inizializzazione delle variabili di stato del Monitor			/
//******************************************************************************/   
        
   /**
    * Funzione di stampa dello stato della risorsa
    */
   private synchronized void stampaStato()
   {
       System.out.println();
       for(int i=0; i<vani; i++) 
	   System.out.print("----");
       System.out.println();
       for(int i=0; i<vani; i++) 
	   System.out.print("| "+cap_vano[i]+" ");
       System.out.print("|\n");
       for(int i=0; i<vani; i++) 
	   System.out.print("----");
       System.out.println();
   }

    public DepositoBagagli(int vani, int bagagli) {
        this.vani = vani;
        this.bagagli = bagagli;
        cap_vano = new int[vani];
        for (int i = 0; i < vani; i++)
          cap_vano[i] = 0;
        contatore_sospesi = 0;
        coda = new Cond(this);
    }

//******************************************************************************/ 
// dichiarazione e definizione delle procedure di Entry sul Monitor		/
//******************************************************************************/ 
   public int Lascia(int n_bag, String nomeUtente) {

        // come prima istruzione bisogna invocare entraMonitor
        entraMonitor();

        // IN QUESTA SOLUZIONE, PER SEMPLICITA' NON CONSIDERIAMO
        // IL PROBLEMA DELLA RICONOSCIBILITA' DEI BAGAGLI
        boolean trovato_vano = false;
        int quale_vano = -1;

        while (!trovato_vano)
        {
              System.out.println(nomeUtente+" devo depositare "+n_bag+" bagagli...");
              
              stampaStato();

              // cerco un vano libero
              for (int i = 0; (i < vani) && (!trovato_vano); i++)         	  						 
                if (cap_vano[i] + n_bag <= bagagli)
                {
                  trovato_vano = true;
                  quale_vano = i;                
                }
              
              // mi sospendo solo se nessun vano e' libero
              if (!trovato_vano)
              {
                System.out.println(nomeUtente+" non ho trovato il vano mi devo sospendere");
                contatore_sospesi++;
                coda.Wait();
                contatore_sospesi--;
              }
                         
        }

        // occupo le risorse
        cap_vano[quale_vano] += n_bag;

        System.out.println(nomeUtente+" occupo il vano "+quale_vano);
        
        stampaStato();
        
        // come ultima istruzione bisogna invocare esciMonitor
        esciMonitor();

        // rischioso! ho gia' liberato il monitor
        // Si potrebbe usare un oggetto che, per default, viene passato per riferimento
        return quale_vano;
    }
    

   public void Prendi(int vano, int n_bag, String nomeUtente) {

        // come prima istruzione bisogna invocare entraMonitor
        entraMonitor();

        System.out.println(nomeUtente + " prende i bagagli");
        cap_vano[vano] -= n_bag;

        stampaStato();
        
        // segnalo gli utenti sospesi
        int s = contatore_sospesi;
        for (int i = 0; i < s; i++)
          coda.Signal();

        // come ultima istruzione bisogna invocare esciMonitor
        esciMonitor();
        }

     
}    // QUESTA GRAFFA TERMINA LA CLASSE MONITOR 
